###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
# Copyright (c) 2006 Mehdi Abaakouk
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import os
import gst
import gobject
import gnomevfs
import gtk
from time import time,sleep
from datetime import datetime
import gst
import threading
import urllib
from xml.dom import minidom
import amazon
import traceback
try: import gpod
except: pass
import threading

"""This is a dict with read/write metadata fonction for each extention """
WRITE_EXTENTIONS = {}
READ_EXTENTIONS = {}

PLAYLIST_EXTENTION = [".m3u",".pls"]

from helper import helper 
import utils
import config
import const
import formats.gsttag
import formats.mp4
import formats.mutagen_tag
"""
import formats.oggvorbis
import formats.mp3
import formats.flac
"""


def get_supported_extention():
    string = "Extension support tag reading: \n"+str(READ_EXTENTIONS.keys())
    string += "\nExtension support tag writting: \n"+str(WRITE_EXTENTIONS.keys())
    string += "\nAll Gstreamer supported file can be read, but more slower then built-in extention"
    return string

if False:
    print get_supported_extention()


"""
List of album covers that I have already tried
to download on amazon website and which failed
this list is reinitialized every 30min
"""
COVER_TO_SKIP = []
def reinit_skip_cover():
    COVER_TO_SKIP = []
REINIT_COVER_TO_SKIP_TIME = 100*60*30
gobject.timeout_add(REINIT_COVER_TO_SKIP_TIME,reinit_skip_cover)


"""
Class to manage policy between action and song type

"""
class SongType:
    LOCAL_FILE, \
    LOCAL_PODCAST, \
    LOCAL_WEBRADIO, \
    REMOVABLE_FILE, \
    REMOVABLE_PODCAST, \
    REMOVABLE_WEBRADIO, \
    REMOTE_FILE, \
    REMOTE_WEBRADIO, \
    UNKNOWN, \
    AUDIOCD_TRACKS = range(0,10)
    
    def __init__(self):
        self.file_transfert_to = [
                                   self.LOCAL_FILE,
                                   self.REMOVABLE_FILE
                                   ]
        self.file_transfert_from = [
                                   self.LOCAL_PODCAST,
                                   self.LOCAL_WEBRADIO,
                                   self.LOCAL_FILE
                                   ]
        self.podcast_transfert_to = [
                                   self.LOCAL_PODCAST
                                   ]
        self.podcast_transfert_from = []
        self.shoucast_report=[
                               self.LOCAL_FILE,
                               self.REMOVABLE_FILE,
                               self.AUDIOCD_TRACKS
                               ]
        self.podcast=[
                               self.LOCAL_PODCAST,
                               self.REMOVABLE_PODCAST
                               ]
        self.webradio=[
                               self.LOCAL_WEBRADIO,
                               self.REMOVABLE_WEBRADIO,
                               self.REMOTE_WEBRADIO
                               ]
        self.wikipedia = [
                           self.LOCAL_FILE,
                           self.REMOTE_FILE,
                           self.REMOVABLE_FILE,
                           self.AUDIOCD_TRACKS
                           ]
        self.lyrics = [
                           self.LOCAL_FILE,
                           self.REMOTE_FILE,
                           self.REMOVABLE_FILE,
                           self.AUDIOCD_TRACKS
                           ]
        self.lastfm = [
                           self.LOCAL_FILE,
                           self.REMOTE_FILE,
                           self.REMOVABLE_FILE,
                           self.AUDIOCD_TRACKS
                           ]
        self.auto_refresh_tag = [
                               self.LOCAL_WEBRADIO,
                               self.REMOVABLE_WEBRADIO,
                               self.REMOTE_WEBRADIO
                               ]
                               
        self.do_check_exist = [
                           self.LOCAL_FILE
                           ]
                           
        self.disable_cover = [
                               self.LOCAL_WEBRADIO,
                               self.REMOVABLE_WEBRADIO,
                               self.REMOTE_WEBRADIO
                               ]

sType = SongType()
"""
Some note about tag:

For podcast:
    album contains the podcast feed name
    
    
For iradio:
    title contains the radio name
    album contains the web site of the radio
    artist contains the now_playing title
    
"""

class Song(dict):
    def __init__(self,iterable=[]):
        dict.__init__(self,iterable)
        self["tagged"] = False
        if not self.has_key("##song_type##"):
            self["##song_type##"] = sType.UNKNOWN

    def get_type(self):
        return self["##song_type##"]
    
    def set_type(self,type):
        self["##song_type##"] = type

    def reinit_key_modified(self):
        self.key_to_update = []
        
    def get_filter(self):
        """self.sprint("genre").strip().lower(),"""

        return " ".join([
                self.get_str("artist").lower(),
                self.get_str("album").lower(),
                self.get_str("title").lower(),
                        ])
            
    def get_str(self,key,xml=False):
        value = dict.get(self,key)    
        
        #Shorcut to don't write special cell renderer
        if key == "radio_person":                
            value = "%s/%s"%(self.get_str("#person"),self.get_str("#max_person")) 
            
        if self.get_type() in sType.podcast and key=="artist":
            value = self.get_str("#date")
        if key=="feed":
            value = self.get_str("album")
        if key=="#duration" and value!=None:
            value = utils.duration_to_string(value)
        if key=="#duration" and value==None and self.get_type() in sType.podcast :
            value = _("Not downloaded")
        if value and (key=="#rssdate" or key=="#date") and self.get_type() in sType.podcast :
            value = datetime.fromtimestamp(int(value)).strftime("%x %X")[:-3]
        if value and key=="#lastplayed":
            value = datetime.fromtimestamp(int(value)).strftime("%x %X")[:-3]
        if not value and key in ["#lastplayed","#playcount"]:
            value = _("Never")
        if not value and (key=="#rssdate" or key=="#date"):
            value = _("Unknown")
        if key == "#bitrate" and value!=None:
            value = "%dk"%(value/1000)
        if not value:
            value = ""
        if key in ["#person","#max_person"] and not value:
            value = 0            
        if isinstance(value,int):
            value = "%d"%value
        if key=="uri":
            value = gnomevfs.unescape_string_for_display(value)
        if key=="title" and value=="":
            value = gnomevfs.unescape_string_for_display(self.get_filename())
        if key in ["album","genre","artist","title"]:
            value = utils.format_tag(value)
            
        if xml:
            return utils.xmlescape(value)
        else:
            return value
            
    def get_sortable(self,key):
        if self.has_key("sort_key_"+key):
            return self.get("sort_key_"+key)
        else:
            value = self.get(key)
            if not value:
                return ""
            if key in ["uri"]:
                value = value.lower()
            if key == "radio_person":
                print self.get("#person")
                return self.get("#person")
            return value
            
        
    def _get_sortable(self,key):
        value = self.get(key)    
        if not value:
            return None
        if key in ["album","genre","artist","title"]:
            value = utils.format_tag(value).lower()
        if key in ["uri"]:
            value = value.lower()
        return value
        
        
    def __getitem__(self,key):
        if self.has_key(key):
            return dict.__getitem__(self,key)
        else:
            if key=="feed":
                return dict.__getitem__(self,"album")
            if key[:1] == "#" and key!="#track": #len(key)>0 and 
                return 0
            else:
                return None
            
    def get(self,key):
        return self.__getitem__(key)
    
    def set(self,key,value):
        self[key] = value
        self.set_str(key,value)
        
    def __setitem__(self,key,value):
        if key == "#track" and value!=None and  not isinstance(value,int) and value.rfind("/")!=-1 and value.strip()!="":
            value = value.strip()
            value = value[:value.rfind("/")]

        if key[0]=="#":
            if value==None or value=="" and key == "#duration":
                value = "0"
            try: value = int(value)
            except:
                print "Failed set key ",key," on song ",value,self.get("uri")
                return
            
        if key == "uri" and utils.get_protocol(value)=="file://":
            dict.__setitem__(self,"path",gnomevfs.get_local_path_from_uri(value))
        elif key == "uri" and self.has_key("path"):
            del self["path"]
            
            
        if key in ["album","genre","artist","title"]:
            value2 = utils.format_tag(value).lower()
            dict.__setitem__(self,"sort_key_"+key,value2)
                          
        dict.__setitem__(self,key,value)
        
    def __delitem__(self,key):
        
        if key == "uri":
            dict.__delitem__(self,"path")    
        if key in ["album","genre","artist","title"]:
            dict.__delitem__(self,"sort_key_"+key)   
            
        dict.__delitem__(self,key) 
        
    def __sort_key(self):   
        return(
                self.get_sortable("artist"),
                self.get_sortable("album"),
                self.get_sortable("#track"),
                self.get_sortable("title"),
                self.get_sortable("date"),
                self.get_sortable("#bitrate"),
                self.get_sortable("uri")
                )    
    sort_key = property(__sort_key)
    
    def __sort_key2(self):
        return(
                self.get_sortable("genre"),
                self.get_sortable("artist"),
                self.get_sortable("album"),
                self.get_sortable("#track"),
                self.get_sortable("title"),
                self.get_sortable("uri")
                )    
    browser_sort_key = property(__sort_key2)

    def __hash__(self):
        return hash(self.get("uri"))


    def __cmp__(self, other):
        if not other: return -1 
        try: return cmp(self.sort_key, other.sort_key)
        except AttributeError: return -1

    def __eq__(self,other):
        try:return self.get("uri")==other.get("uri")
        except:return False

    def exists(self):
        if self.get_type() in sType.do_check_exist:
            return gnomevfs.exists(self.get("uri"))
        else:
            return self.get("uri")
    """""""""""""""""""""
        FILE READER
    """""""""""""""""""""
    """
    Send a copy of song to reading tag thread
    """
    def async_read_from_file(self):
        thread_tag_reader.add_song(Song(self))
        
    def read_from_file(self):
        if self.get_protocol()=="file://" and not self.exists():
            self["tagged"] = False
            return False
        """if self.type == "iradio" :
            return False"""
            
        if self.get_protocol()=="file://" and READ_EXTENTIONS.has_key(self.get_ext()):
          
            res = False
            try: 
                res = READ_EXTENTIONS[self.get_ext()](self)
            except Exception, inst:
                #FIXME: Add a real traceback support
                print "W: Error while loading ("+self.get("uri")+")\nTracback :",inst
                self.last_error = _("Error while reading")+": "+self.get_filename()
                self["tagged"] = False
                try:
                    fileinfo = gnomevfs.get_file_info(self.get("uri"))
                    self["#size"] = fileinfo.size
                    self["#mtime"] = fileinfo.mtime
                    self["#ctime"] = fileinfo.ctime
                except:
                    pass
                return False
            else:
                try:    
                    #stats = os.stat(self.get_path())
                    fileinfo = gnomevfs.get_file_info(self.get("uri"))
                    self["#mtime"] = fileinfo.mtime
                    self["#ctime"] = fileinfo.ctime
                    self["tagged"] = True
                except:
                    pass
                if not res:
                    self.last_error = _("Error while reading")+": "+self.get_filename()    
                return res

        else:
           print "GST Read"
           try: 
               if formats.gsttag.read(self):
                   self["tagged"] = True
                   """fileinfo = gnomevfs.get_file_info(self.get("uri"))
                   self["#size"] = fileinfo.size
                   self["#mtime"] = fileinfo.mtime
                   self["#ctime"] = fileinfo.ctime"""
                   return True
               else:
                   self["tagged"] = False
                   return False
           except formats.gsttag.GstTagReadingError:
               return False
           else:
               return True

    def read_from_musicbrainz(self):

        class MusicbrainzWindow(gtk.Dialog):
            def __init__(self,text,path,data):
                gtk.Dialog.__init__(self,"Musicbrainz search",None,
                     gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                         (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                          gtk.STOCK_OK, gtk.RESPONSE_ACCEPT)
                     )

                self.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
                self.set_resize_mode(False)
                self.set_border_width(6)
                self.set_modal(True)
                self.set_property("skip-taskbar-hint",True)
                self.set_has_separator(False)
        
                self.tree = gtk.TreeView()
                self.tree.insert_column_with_attributes(-1, "Found", gtk.CellRendererText(), text=1)
                self.tree.set_model(gtk.ListStore(gobject.TYPE_INT,gobject.TYPE_STRING))
                self.tree.connect("row-activated",self.on_activate)
                for item in data:
                    self.tree.get_model().append((item["index"],item["text"]))
                    
                from widget.misc import ScrolledWindow
                l = gtk.Label(text)
                l.set_alignment(0,0.5)
                self.vbox.pack_start(l,False,True)
                e = gtk.Entry()
                e.set_text(path)
                e.set_sensitive(False)
                self.vbox.pack_start(e,False,True)
                self.vbox.pack_start(ScrolledWindow(self.tree),True,True)
                self.vbox.set_spacing(6)
                
            def run(self):
                self.show_all()
                res = super(MusicbrainzWindow,self).run()
                if res == gtk.RESPONSE_ACCEPT:
                    model, path = self.tree.get_selection().get_selected()
                    return model[path][0]
                else:
                    return None       
                
            def on_activate(self,tree, path,a):
                self.response(gtk.RESPONSE_ACCEPT)
                        
        print "Fetch metadata information"
        if not self["musicip_puid"] or len(self["musicip_puid"])!=36:
            print "Make PUID fingerprint"    
            if os.system("puid 001bd3a391cc704bb97cbdedb33336d5 \"%s\" > /tmp/listenPUID"%self.get_path().replace('"','\"'))!=0:
                return False
            else:
                puid = gnomevfs.read_entire_file("file:///tmp/listenPUID").replace("\n","").replace("\r","")
                if puid and len(puid)==36:
                    self["musicip_puid"] = puid
                else:
                    return False
                os.unlink("/tmp/listenPUID")
          
        import musicbrainz2.webservice as ws
        q = ws.Query()
        print "PUID:",self["musicip_puid"]
        print "Query musicbrainz..."
        try:
            include = ws.TrackIncludes( artist=True, releases=True, puids=True)
            filter = ws.TrackFilter(puid=self["musicip_puid"])
            res = q.getTracks(filter)
        except: 
            print "Failed to retreive information from musicbrainz"
            return False
        if len(res)<=0:
            print "No Metadata Found"
            return False
        else:
            if len(res)==1:
                index = 0
            else:
                data = []
                i = 0
                for r in res:
                    track = r.getTrack()
                    score = r.getScore()
                    text = utils.xmlescape(track.getTitle()+" - "+track.getArtist().getName())
                    if score:
                        text += " (%d)"%(score)
                                            
                    data.append((score,i))
                    i += 1
                data.sort()
                """gtk.gdk.threads_enter()
                w = MusicbrainzWindow(_("Choose the correct album"),self.get_path(),data)
                index = w.run()
                w.destroy()"""
                index = data[0][1]
                
            
            if index!=None and len(res)>0:
                track = res[index].getTrack()
                self["title"] = track.getTitle()
                self["artist"] = track.getArtist().getName()
                releases = track.getReleases()
                if len(releases)==1:
                    index = 0
                else:
                    data = []
                    i = 0
                    for r in releases:
                        data.append({"index":i,"text":utils.xmlescape(r.getTitle())})
                        i += 1
                    
                    """w = MusicbrainzWindow(_("Choose the correct album"),self.get_path(),data)
                    index = w.run()
                    w.destroy()"""
                    index = 0
                    
                if index!=None and len(releases)>0:
                    self["album"] = releases[index].getTitle()
                    self["date"] = releases[index].getEarliestReleaseDate()
            
        return True

            
    """""""""""""""""""""
        FILE WRITER
    """""""""""""""""""""


    def write_to_file(self):
        if self.get_protocol()!="file://":
            self.last_error = self.get_protocol()+" "+_("Protocol not supported")
            return False
        if not os.path.exists(self.get_path()):
            self.last_error = self.get_filename()+_(" doesn't exist")
            return False
        if not os.access(self.get_path(),os.W_OK):
            self.last_error = self.get_filename()+_(" doesn't have enough permission")
            return False
        res = False
        if WRITE_EXTENTIONS.has_key(self.get_ext()):
            try: res = WRITE_EXTENTIONS[self.get_ext()](self)
            except Exception, inst:
                print "W: Error while writting ("+self.get_path()+")\nTracback :",inst
                print traceback.format_exc()
                self.last_error = _("Error while writting")+": "+self.get_filename()
                return False
            else:
                if not res:
                    self.last_error = _("Error while writting")+": "+self.get_filename()
                return res
        else:
            self.last_error = self.get_filename()+_(": file formats don't support tag writting")
            return False

    """
    Some filename manipulation
    """
    def get_path(self):
        return self.get("path")
            

    def get_protocol(self):
        return utils.get_protocol(self.get("uri"))

    def get_ext(self,complete=True):
        return utils.get_ext(self.get("uri"),complete)

    def get_filename(self):
        value = self.get("uri") 
        try:
            return utils.fsdecode(gnomevfs.get_file_info(str(value)).name)
        except:
            """
            FIXME: 
                i don't meet this bug again
                i my memory, i have edit some tag with muzikbrainz and without
                And 3 song have been created without uri filed!!
                And all function that use uri failed
                
                here return value for now and print tag information for debugging
            """
            #print "E:Song:get_filename:gnomevfs.get_file_info failed on ", self
            return value

    """
    Delete album cover from harddisk
    """
    def remove_cover(self):
        image_path = self.get_cover_path()
        if image_path in COVER_TO_SKIP:
            del COVER_TO_SKIP[COVER_TO_SKIP.index(image_path)]
        if os.path.exists(image_path):
            os.unlink(image_path)
    """
    The lyrics filename 
    Use same as quodlibet format
    """
    lyric_uri = property(lambda self: "file://"+utils.fsencode(
        os.path.join(os.path.expanduser("~/.lyrics"),
                     self.get_str("artist").replace('/', '')[:128],
                     self.get_str("title").replace('/', '')[:128] + '.lyric')))

    """
    Update played information
    """
    def update_played_information(self):
        if self.get("#playcount"):
            self["#playcount"] = self.get("#playcount")+1
        else:
            self["#playcount"] = 1
        self["#lastplayed"] = time()
    
    """
    Return the name of the cover file without extention
    """
    def get_cover_search_str(self):
        art = ""
        if not self.get_type() in sType.podcast and self.get_str("artist")!="":
            art=self.get_str("artist")+"+"
        if self.get_str("album")!="":
            art+=self.get_str("album")

        art = art.replace(os.sep,"")
        art = utils.filter_info_song(art).encode('utf-8')
        return art
    
    """
    Return path of the local album art
    It can not exist
    """
    def get_cover_path(self):
        if self.get_type() in sType.disable_cover:
                return const.DEFAULT_COVER
        return const.CONFIG_DIR+"cover/"+self.get_cover_search_str()+".jpg"

    """
    Return path of the existing album art to display
    Or default cover if not found
    Must be ONLY use in a thread
    because it use amazon to get cover and if they don't have internet connection listen freeze
    """

    def get_cover(self,try_web=True):
            
        default_image_path = const.DEFAULT_COVER
        if self.get_type() in sType.disable_cover:
                return default_image_path    
            
        basedir = os.path.dirname(os.path.realpath(__file__))+"/"
        art = self.get_cover_search_str()

        image_path_disable = const.CONFIG_DIR+"cover/"+art+".jpg.#disable#"
        if os.path.exists(image_path_disable):
            return default_image_path

        image_path = const.CONFIG_DIR+"cover/"+art+".jpg"
        if os.path.exists(image_path):
            return image_path
        else:
            if image_path in COVER_TO_SKIP:
                return default_image_path

            """
            search in local directory
            artist.jpg,folder.jpg,album.jpg and same with png
            """
            if self.get("uri")!=None and self.get_protocol()=="file://":
                filename = self.get_path()
                path = filename[:filename.rfind("/")]
                if os.path.exists(path):
                    list_file = os.listdir(path)
                    for f in list_file:
                        #print f.lower()
                        if f.lower() in ["artist.jpg","folder.jpg",".folder.jpg","album.jpg","artist.png","folder.png",".folder.png","album.png","cover.jpg","cover.png"]:
                            try : pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(path+"/"+f,const.COVER_SIZE["x"],const.COVER_SIZE["y"])
                            except gobject.GError: pass
                            else:
                                if os.path.exists(image_path):
                                    os.unlink(image_path)
                                pixbuf.save(image_path, "jpeg", {"quality":"85"})
                                del pixbuf
                                #print "Local cover found: ",f
                                return image_path


            if not try_web:
                return default_image_path
            else:
                try:
                    #print "Download a cover"
                    if self.get_type() in sType.podcast:
                        if self.get("imagerss"):
                            res = urllib.urlretrieve(self.get("imagerss"), image_path)
                        else:
                            return default_image_path  
                    else:
                        """ Try Amazon search """
                        if True:
                            amazon.setLicense("0RKH4ZH1JCFZHMND91G2")
                            bags = amazon.searchByKeyword(utils.remove_accents(art),type="lite", product_line="music")
                            res = urllib.urlretrieve(bags[0].ImageUrlSmall, image_path)
                        else:
                            #Lastfm version but not really usage for now
                            lastfm_url = "http://www.last.fm/music/"+urllib.quote(self.get_str("artist").encode("utf-8"))+"/"+urllib.quote(self.get_str("album").encode("utf-8"))
                            fp = urllib.urlopen(lastfm_url)
                            html = fp.read()
                            import re
                            res_exp = re.search("<div class=\"cover\"><a.*?src=\"(.*?)\".*?></a></div>",html,re.S)
                            if res_exp:
                                lastfm_img_url = res_exp.group(1)
                                res = urllib.urlretrieve(lastfm_img_url, image_path)
                            else:
                                return default_image_path
                except:
                    COVER_TO_SKIP.append(image_path)
                    return default_image_path
                else:
                    if res:
                        #Change resolution
                        try: pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(image_path,const.COVER_SIZE["x"],const.COVER_SIZE["y"])
                        except gobject.GError: return default_image_path
                        else:
                            if os.path.exists(image_path):
                                os.unlink(image_path)
                            pixbuf.save(image_path, "jpeg", {"quality":"85"})
                            del pixbuf
                            return image_path
                    else:
                        COVER_TO_SKIP.append(image_path)
                        return default_image_path



class ThreadTagReader:
    def __init__(self):
        
        self.dbg = False
        
        self.condition = threading.Condition()
        nb_thread = 1
        
        for i in range(0,nb_thread):
            t = threading.Thread(target=self.thread)
            t.setDaemon(True)
            t.start()
        self.queue = []
        
    def add_song(self,song):
        self.condition.acquire()
        self.print_dbg("add_song",song.get("uri"))
        self.queue.append(song)
        self.condition.notify()
        self.condition.release()
    
    def thread(self):
        while True:
            self.condition.acquire()
            while not self.queue:
                self.print_dbg("wait")    
                self.condition.wait()
            song = self.queue.pop(0)
            self.condition.release()
            self.print_dbg("read_from_file:",song.get("uri")) 
            song.read_from_file()
            gobject.idle_add(helper.change_songs,[song])
            self.print_dbg("helper.change_songs:",song.get("uri")) 
       
    def print_dbg(self,*args):
        if self.dbg: print "DBG:ThreadTagReader:",args     
thread_tag_reader = ThreadTagReader()
